Versionsverlauf
===============

## [Noch nicht veröffentlicht]

- derzeit keine Änderung

## [Version 5.13.0] - 2025-06-28

Erweiterung in `de.bsvrz.kex.tls.osi7.conversion.Fg003Typ076`
- Publizierung der logischen Umfeldsensordaten für FG3 Typ076 (EisFilmDicke)

## [Version 5.12.0] - 2024-01-19

Typ 32 in FG004Tls2012-Umsetzungsmodul deaktiviert. Fixes https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/-/issues/18

## [Version 5.11.0] - 2023-07-07

In der Klasse `de.bsvrz.kex.tls.osi7.conversion.FgAllDefault` in der Methode für die Umsetzung der DEFehlerMeldung den
Zustand StörKRI (3) ergänzt.

```java
public ResultData Fg255Typ001Id001AtgTlsGloDeFehlerAspTlsAntwort(DeBlock deBlock,Data data,DataDescription dataDescription){
        ResultData resultData=null;

        // Fehlercode-Byte aus Telegramm -------------------------------------------------------------------------------
        int _Fehlercode_=deBlock.getDeData().readUnsignedByteAsInt();

        _de.setOk(false);// Fehlerzustand der DE auf "defekt setzen".
        switch(_Fehlercode_&0x03){
        case 0:
        data.getUnscaledValue("DEFehlerStatus").setText("ok");
        _de.setOk(true);// nur bei De-Gutmeldung Fehlerzustand der De auf "ok" setzen.
        break;
        case 1:
        data.getUnscaledValue("DEFehlerStatus").setText("StörEAK");
        break;
        case 2:
        data.getUnscaledValue("DEFehlerStatus").setText("StörSM");
        break;
        case 3:
        data.getUnscaledValue("DEFehlerStatus").setText("StörKRI");
        break;
        default:
        debug.warning("DeFehlerStatus ungültig : "+_Fehlercode_+Debug.NEWLINE+
        "De-Block (Osi7Adresse-DeNummer-FG-Typ-Id): "+deBlock.getLongKey()+" verworfen:"+Debug.NEWLINE+
        deBlock.toString());
        return resultData;

        ...


        }
```

**WICHTIG:** Diese Version setzt die Verwendung 
  - des aktuellen `kv.inovat` vom 05.07.2023 mit dem `kb.tmKExTlsGlobal`ab
Version **27** 
  -  und (siehe Anmerkung zu Version 5.10.0-BETA) die Einbindung des `kb.tmKExTlsFG210` ab Version 1 voraus.

## [Version 5.10.0-BETA] - 2021-10-03

Implementierung der FG210 (Parken und Parkplatzüberwachung) gemäß letzter Spezifikation BASt.

Grundlage war das Dokument `TLS2012_a6_2_xx_D2019-12-04.pdf`, welches im Repository
unter `Dokumente/TLS2012_a6_2_xx_D2019-12-04.pdf` abgelegt ist.

**Das Dokument ist bis heute (Stand 08.2021) nicht offiziell in der TLS aufgenommen, sondern
befindet sich weiterhin im Entwurfsstadium. Ob es noch einmal geändert wird, ist ungewiss.**

**WICHTIG:** Diese Version setzt die Verwendung des aktuellen `kv.inovat` vom 03.10.2021 mit dem
neuen `kb.tmKExTlsFG210` in Version 1 voraus, diese enthält das Teilmodell mit Datenmodellierung zur Anbindung und zum
Datenaustausch mit Geräten, die gemäß TLS 2012 in der FG 210 (Parken und Parkplatzüberwachung) angebunden sind.

### Neu

- In der Klasse `de.bsvrz.kex.tls.osi7.De` zusätzliche Einträge für den neuen DE-Typen `typ.dePup` für die FG210
  ergänzt (Pup steht für **P**arken **u**nd **P**arkplatzüberwachung, die naheliegende Abkürzung PPü bzw. PPue wurde
  bereits in früheren projektspezifischen KB verwendet).
- Neue Klasse `de.bsvrz.kex.tls.osi7.conversion.Fg210Default` mit den Umsetzungsmethoden für die FG210 als
  Standardmodule für die FG210 implementiert.

### Geändert

- Updates Kommentare und Copyrighteinträge
- Update Gradle-Version und Dependencies

## [Version 5.9.1] - 2021-04-30

### Behoben

- Aufrufparameter `-pidBetriebsMeldungsVerwaltung` korrigiert, behebt den
  BUG [Aufrufparamter -pidBetriebsMeldungsVerwaltung funktioniert nicht - #14](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/-/issues/14)

- [Bessere Fehlerbehandlung bei fehlenden Typen - #13](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/-/issues/13):

  Vor dem Anmelden der Daten wird jetzt getestet, ob ATG und/oder ASP eventuell nicht ermittelbar
  sind, weil z. B. ein benötigter KB nicht vorhanden ist oder die PID falsch angegeben wurde. In
  diesem Fall wird eine Warnung mit entsprechenden Informationen ausgeben und die Anmeldung für
  diesen Eintrag (ATG/ASP-Kombination) übersprungen.

### Updates

- `de.bsvrz.gradle.nerzswe` auf Version `0.26.0` und Gradle auf Version `7.0`

## [Version 5.9.0] - 2021-02-06

### Behoben

- in der Klasse

    - `Fg001HeuschBoesefeldt.java`

      die Methode

    - `public ResultData Fg001Typ204Id004AtgVerkehrsDatenLangZeitIntervallAspExterneErfassung(DeBlock deBlock, Data data, DataDescription dataDescription)`

  um die Berechnung des Wertes `qKfz` ergänzt, da dieser Wert für die Erstellung der BASt-FG1-Daten
  benötigt wird (Wert war bisher immer `0`, da Wert von den HB-Zentralen nicht geliefert wird).

## [Version 5.8.0] - 2020-10-26

### Neu

#### Einschränkung von Jobnummern

Die von der KEXTls vergebenen Jobnummern für Telegramme liegen gemäß TLS zwischen 1 und 255.

Für die KRI-2X/KRI-2b in NRW ist es erforderlich, dass jeder Client nur einen bestimmten (
anpassbaren) Jobnummernbereich verwendet. Soll ein individueller Jobnummernbereich eingestellt
werden, können die notwendigen Parameter über folgende Einträge bei der
`atg.protokollEinstellungenStandard` des Anschlusspunkts für alle Verbindungen an diesem
Anschlusspunkt eingestellt werden:

Name = `osi7.jobNummerMinimal`
Wert = 1–255, Defaultwert ist 1

Name = `osi7.jobNummerMaximal`
Wert = 1–255, Defaultwert ist 255

**WICHTIG**: Damit dieses Feature genutzt werden kann, müssen die folgenden SWE jeweils in
mindestens der angegebenen Version verwendet werden:

- `de.bsvrz.kex.tls.osi2osi3` ab Version 3.10.0
- `de.bsvrz.kex.tls.osi2osi3.osi2.tlsoip` ab Version 2.2.0

Setzt den
Featurewunsch [Einschränkung von Jobnummern - #12](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/-/issues/12)
um.

#### Auschaltcode für WVZ immer 0

In der Version 5.6.0 wurde in der Klasse `Fg004Default.java` bei der Übernahme von _validWvzCode
eine Plausibilitätsprüfung eingebaut, sodass die Werte 0 und 255, welche zu Fehlern bei der
Verwendung führen, nicht mehr übernommen werden. Aktuell versucht KExTLS, einen gültigen Stellcode
zu bestimmen und diesen zu übertragen (siehe auch Änderung
in [#8](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/-/issues/8) (closed)), wobei die
Werte 0 und 255 nicht verwendet werden.

Eigentlich sollte der Stellcode beim Ausschalten ohne Relevanz sein (TLS-konform sind alle Werte von
0-255 beim Ausschalten, unabhängig davon, ob der jeweilige Code beim WVZ bekannt ist).

Einige Entwickler versteifen sich aber darauf, dass auch beim Ausschalten ein gültiger Code
verwendet werden muss und schalten das WZG ansonsten nicht aus (obwohl kein Mensch erklären kann,
warum hier so ein unnötiger Programmieraufwand getrieben wird, der zudem einen sicheren Betrieb
erheblich erschwert...Im Zweifelsfall kann nämlich eine Fehlanzeige nicht ohne weiteres über eine
manuelle Schaltung ausgeschaltet werden, weil die Liste der gültigen Anzeigecode nicht bekannt
ist!!).

Aus diesem Grunde wurde in der Version 5.6.0 das entsprechende Verhalten implementiert (was bei
TLS-konformen Anlagen in Normalfall ebenfalls funktioniert).

In NRW gibt es einige dWiSta, die zum Ausschalten Stellcode/Funktionsbyte = 0/0 benötigen. (
Anscheinend wird das Funktionsbyte ignoriert und nur der Stellcode berücksichtigt, wobei Stellcode 0
als "Aus" verstanden wird.)

Aus diesem Grund gibt es jetzt die neue, von der Klasse `Fg004Default.java` abgeleitete
Klasse `Fg004DefaultMitAusschaltCode0.java`, bei der zum Ausschalten Stellcode/Funktionsbyte = 0/0
sind.

Setzt den
Featurewunsch [Stellzustand/Schaltcode-Verhalten beim Ausschalten FG4 - #11](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/-/issues/11)
um.

#### Spezifische Umsetzungsklassen für NW/dWiSta

Es wurden zwei zusätzliche Umsetzungsklassen für NW übernommen:

- `de.bsvrz.kex.tls.osi7.conversion.nw.dwista.Fg004Tls1993`, abgeleitet von der neuen
  Umsetzungsklasse `Fg004DefaultMitAusschaltCode0.java`
- `de.bsvrz.kex.tls.osi7.conversion.nw.dwista.Fg004Tls2012`, abgeleitet von der neuen
  Umsetzungsklasse `Fg004DefaultMitAusschaltCode0.java`

#### Spezifische Umsetzungsklassen für NW-HB angepasst

Es folgende Umsetzungsklassen für NW angepasst:

- `de.bsvrz.kex.tls.osi7.conversion.nw.vrz.Fg001HeuschBoesefeld`

Dabei wurde die (bisher auskommentierte) Korrektur des HB-UNIX-Zeitstempels zu UTC von 1h bei der
Interpretation des Zeitstempels für Langzeitdaten wieder aktiviert, da eine Differenz zwischen dem
Zeitstempel der Langzeitdaten auf der HB-Oberfläche und dem Zeitstempel der Langzeidaten auf den
ERZ-Systemen von 1 Stunde vorlag.

## [Version 5.7.0] - 2020-04-28

### Behoben

- in der Klasse

    - `de.bsvrz.kex.tls.osi7.conversion.Fg001Default`
      die Methode

    - `public ResultData Fg001Typ079Id004AtgVerkehrsDatenLangZeitIntervallAspExterneErfassung(DeBlock deBlock, Data data, DataDescription dataDescription)`

  um die Berechnung des Wertes `qKfz` ergänzt, da dieser Wert für die Erstellung der BASt-FG1-Daten
  benötigt wird (Wert war bisher immer `nicht ermittelbar`).

## [Version 5.6.0] - 2020-02-18

### Behoben

- in der Klasse `Fg004Default.java` bei der Übernahme von _validWvzCode eine Plausibilitätsprüfung
  eingebaut, sodass die Werte 0 und 255, welche zu Fehlern bei der Verwendung führen, nicht mehr
  übernommen werden.

- Schönheitsfehler in der Methode `Fg004Typ033Id003AtgTlsWzgGrundEinstellungAspParameterSoll`
  korrigiert, anstatt der Funktion wurde der Stellcode zum Ausschalten auf 0 gesetzt, war aber
  bisher kein Problem, da die Funktion mit 0 initialisiert wird.

Behebt den Bug https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/issues/8 "Fehler bei der
Übernahme des gültigen WvzCodes für die Ausschaltung beheben".

### Geändert

- in der Klasse `Fg004Default.java` den
  Konstruktor `Fg004Default(ClientDavInterface daf, Eak eak, De de, boolean lokalAnmelden)`
  hinzugefügt, mit dem festgelegt werden kann, ob die in dieser Klasse versorgten Anmeldungen
  durchgeführt werden sollen oder nicht. Somit kann eine abgeleitete Klassen nur die notwendigen
  Anmeldungen durchführen.

- mit dem neuen Kommandozeilenparameter `-fg4WartezeitVorVersandNachTrigger=1000` kann die Wartezeit
  vor dem Versand der gesammelten FG 4 DE-Blöcke im Bereich von 10 ms bis 10000 ms eingestellt
  werden, wobei der Default-Wert 1000 ms ist. Somit kann ein beschleunigtes Schalten realisiert
  werden.

Realisiert die Features https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/issues/9 "
Änderbarkeit der Zeitdauer vor Versand der gesammelten DeBlöcke beim Programmstart"
und https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/issues/10 "Konstruktor in Fg004Default,
bei dem angegeben werden kann, ob die lokalen Anmeldungen durchgeführt werden sollen".

## [Version 5.5.2] - 2019-10-16

### Behoben

- in der Klasse `Fg004Default.java` in folgenden Methoden die Umsetzung korrigiert (es wird die in
  der TLS für die Darstellung von Zeichen bei Wechseltexten in Wechselverkehrszeichen geforderte
  Zeichenkodierung ISO-8859-1 verwendet):

    - `Fg004Typ050Id005AtgTlsWzgWechselTextAspTlsVorgabe`
    - `Fg004Typ045Id003AtgTlsWzgBildDefinitionAspTlsVorgabe`
    - `Fg004Typ045Id003AtgTlsWzgBildDefinitionAspTlsZustand`

  Behebt den Bug https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/issues/7 "Undefinierte
  Zeichenkodierung in FG4-Umsetzungsscript".

- Hinweis: Lösung aus Version 5.5.1 verworfen und durch Nutzung der ISO-Kodierung ersetzt.

## [Version 5.5.1] - 2019-10-16

### Behoben

- in der Klasse `Fg004Default.java` in folgenden Methoden die Umsetzung korrigiert :

    - `Fg004Typ050Id005AtgTlsWzgWechselTextAspTlsVorgabe`
    - `Fg004Typ045Id003AtgTlsWzgBildDefinitionAspTlsVorgabe`

Behebt den Bug https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/issues/7 "Undefinierte
Zeichenkodierung in FG4-Umsetzungsscript".

### Geändert

- Version des NERZ-Plugin auf 0.17.0 angepasst

## [Version 5.5.0]

### Korrektur Methodenname für FG3, Typ 76, Eisprozent

- Im Mehtodenname `Fg003Typ076Id004AtgTlsUfdErgebnisMeldungEisFilmDickeEFDAspTlsAntwort` war (schon
  immer) ein Tippfehler, so dass die Umsetzungsklasse nie aufgerufen werden konnte.

### Neue Umsetzungsklasse für FG3, Typ 78, Globalstrahlung GLS

- Im `kv.inovat`, `kb.tmKExTlsGlobal` ab Version **26**, wurde in der FG 3 der zusätzliche Typ
  78, **Globalstrahlung** ergänzt. Hierfür wurde eine zusätzliche Umsetzungsklasse erstellt:

    - `de.bsvrz.kex.tls.osi7.conversion.Fg003Typ078`

## [Version 5.4.11]

- NERZ: Umstellung auf Gradle, Build durch FTB und Bereitstellung auf NERZ-Repositories

## Version 5.4.10

- Stand 08.02.2017

### Abruftelegramme sind immer möglich

Über die Methode private boolean isAllowedToSend(De de, DeBlock deBlock) im DeConversionModul werden
der Versand spezifischer DE-Blöcke (insbesondere an DE255 und DE0) unterdrückt, damit z.B. keine
Parameter beim Start an diese DE verschickt werden. Dies führt allerdings auch dazu, dass für die
dort gesperrten DE/FG/TYP-Kombinationen auch nicht die DeBlockAbruf-Telegramme verschickt werden
konnten (z. B. Abruf Konfigurationstabelle an 0/254/34). Methode wurde dahingehend geändert, dass
Telegramme ohne Nutzdaten (also die Abruftelegramme) in jedem Fall an die Streckenstation versandt
werden können.

## 25.12.2016 - V 5.4.9

### Zugriffe auf Methoden und Felder auf public korrigiert

Folgende Zugriffe wurden geändert:

de.bsvrz.kex.tls.osi7.conversion.Fg001VerkehrsDaten.plPruefungUndKorrektur: von protected auf public
de.bsvrz.kex.tls.osi7.conversion.DeConversionModul._config von protected auf public

Grund: Werden eigene Umsetzungsklassen in einem spezifischen Package erstellt, konnte auf die
entsprechenden Variblen/Methoden nicht zugegriffen werden.

## 25.09.2016 - V 5.4.8

### Korrektur in Fg004Default, Auswertung des Funktionsbytes bei Stellzustand

Auswertung des Funktionsbytes bei der Rückmeldung eines Stellzustandes wurde dahingehend koorigiert,
dass nur noch die unteren beiden Bits anstatt der unteren 4-Bit ausgewertet werden, da nur in diesen
die Funktion kodiert wird. Neu (0x03 statt 0x0f):

			// Wenn Funktion = ausgeschaltet, hat Stell-Code keine Bedeutung. Wird deshalb für
			// Protokollausgaben auf -1 = "aus" gesetzt.
			if ((_Funktion_ & 0x03) == 0) {
			    _Stellcode_ = -1;
			}

## 25.06.2016 - V 5.4.7

### Behandlung Sommer-/Winterzeitproblem

Behandlung Sommer-/Winterzeitproblem, wenn UZ auf DST läuft, SST aber nicht
(oder umgekehrt) über Aufrufparameter änderbar (Fehlermanagement #207)

In der Methode EakDefault#setTimeStamp() kann jetzt die spezielle Korrektur, wenn die UZ in DST
läuft, das DST-Flag im Stundenbyte aber nicht gesetzt ist (SSZ läuft nicht in DST), explizit per
Aufrufparamter gesetzt werden.

Aufrufparamter für Sonderbehandlung:

-sonderBehandlungZeitStempelFuerUnterschiedeDSTbeiUZundSST=ja [Default ist nein]

Ist der Aufrufparamter gesetzt (=ja), wird folgende zusätzliche Korrektur des Zeitstempels
verwendet:

            if (TlsApplication.isSonderBehandlungZeitStempelFuerUnterschiedeDSTbeiUZundSST()) {
                if ((isDST)
                    && (!isTlsDST)) {             // Rechner Sommerzeit, SST Winterzeit ==> Verschiebung + 1 Stunde
                    gregorianCalendar.add(Calendar.HOUR_OF_DAY, 1);
                } else if ((!isDST)
                           && (isTlsDST)) {       // Rechner Winterzeit, SST Sommerzeit ==> Verschiebung - 1 Stunde
                    gregorianCalendar.add(Calendar.HOUR_OF_DAY, -1);
                }
            }

## 25.06.2016 - V 5.4.6

### Applikationskennung für Betriebsmeldungen standardmässig auf "KExTlsOsi7".

Die Applikationskennung wurde auf "KExTlsOsi7" gesetzt. (Bisher die Pid des AOE, war aber nicht sehr
hilfreich für den Anwender).

Änderungswunsch von BW (Hr. Bräuner), Mail vom 20.05.2016, "Betriebsmeldungen: Anpassung KEx TLS"

## 13.05.2016 - V 5.4.5

Anpassung Umsetzung FG logisch (zweite Stelle korrigiert, Betriebsmeldungen angepasst.

Anpassung für geänderte Atg mit zusätzlichen Attributten für PlLogisch

            attListe.getItem("Status").getItem("PlLogisch").getUnscaledValue("WertMaxLogisch").set(0);
            attListe.getItem("Status").getItem("PlLogisch").getUnscaledValue("WertMinLogisch").set(0);

Betriebsmeldungen angepasst für FG001Default (Tel. Bräuner vom 13.05.2016)

## 11.05.2016 - V 5.4.4

Anpassung Umsetzung FG logisch

Anpassung für geänderte Atg mit zusätzlichen Attributten für PlLogisch:

            attListe.getItem("Status").getItem("PlLogisch").getUnscaledValue("WertMaxLogisch").set(0);
            attListe.getItem("Status").getItem("PlLogisch").getUnscaledValue("WertMinLogisch").set(0);

ACHTUNG: Diese Version setzt den aktuellen kv.inovat mit dem kb.tmUmfeldDatenGlobal Version 25
voraus!!!

## 08.02.2016 - V 5.4.3

Vermeidung von NullPointerExceptions bei nicht existierenden Umsetzungsmodule

Fehlerhaften bzw. nicht existierenden Umsetzungsmodule in der Versorgung werden von KEx-TLS beim
Start erkannt und mit einer Fehlermeldung dokumentiert. Wenn aber die KEx-Tls trotz der fehlerhaften
Versorgung weiter betrieben wird und dann im späteren Verlauf zu den betroffenen DE Daten übertragen
werden, dann kommt es bei den entsprechenden Zugriffen auf das nicht vorhandene Umsetzungsmodul zu
NullPointerExceptions und in Folge dazu, dass die restlichen DE-Blöcke des empfangenen Telegramms
der gleichen Streckenstation nicht mehr umgesetzt werden. Da an einigen Stellen im Code auf das
Field _conversionModul oder über den entsprechenden getter ohne Null-Prüfung auf das Umsetzungsmodul
zugegriffen wird, wurde die Initialisierungsmethode installConversionModule in der Klasse De so
erweitert, dass auch dann, wenn das gewünschte Umsetzungsmodul nicht instanziiert werden konnte,
trotzdem ein Umsetzungsmodul-Objekt erzeugt wird. Dieses verhindert die NullPointerExceptions und
sorgt beim Empfang eines entsprechenden DE-Blocks für die Ausgabe einer entsprechenden Warnung. Die
Verarbeitung weiterer DE-Blöcke und Einzeltelegramme im gleichen Telegramm wird dann fortgesetzt.

Änderungen entsprechend Mail von KS (R. Schmitz) vom 27.11.2015

SourceDataReferences-Mechanismus mit Referenzen auf MQs

In der VRZ-Leverkusen werden von den HB-Systemen auch Daten von MQ-Objekten übernommen. Damit das
funktioniert, sind im Datensatz atg.gerätTlsÄhnlicheKommunikationsPartnerder VRZ neben DE-Objekten
auch MQ-Objekte zugeordnet. Zur Umsetzung der Telegramme mit dem SourceDataReferences-Mechanismus an
andere Objekte, die eine Referenz auf die MQ-Objekte haben (analog zu den Referenzen z.B. von
Fahrstreifen auf die zugeordneten LVE-DE) war nicht vorgesehen und führte zu einer Warnung:

    Objektreferenz mit unbekanntem Objekttyp wird ignoriert

Die Klasse TlsApplicationLayer wurde jetzt so erweitert, dass auch Referenzen auf Objekte vom
typ.messQuerschnitt zugelassen werden.

Änderungen entsprechend Mail von KS (R. Schmitz) vom 27.11.2015

## 27.09.2015 - V 5.4.2

Anpassungen für Umsetzungen im Bereich NW

Spezifische Anpassungen bei der Umsetzung von Telegrammen Fg254HeuschBoesefeldt und Unterdrückung
des Versands von leeren Datensätzen bei FG 254 DE mit DE-Fehler mit der Kennung "StöSM"
gemäß Mail von KS (R. Schmitz) vom 12.05.2015

## 06.08.2015 - V 5.4.1

Ermittlung Intervalldauer T für UFD-logisches Modell angepasst

Bei der Ermittlung der Intervalldauer T für UFD-Sensoren im logischen Datenmodell wurde der
Algorithmus wie folgt geändert:

- Bei Start wird der Wert aus dem Aufrufparameter
  -standardPeriodenDauerUfdFuerDatenAusfallErkennungInSekunden=60 vewendet (Standardeinstellung ist
  60 Sekunden)

- Wird für die UFD-DE der Betriebsparameter (Soll) an die DE geschickt, wird der Wert aus dem
  Betriebsparamter (Soll) verwendet.

- Wird für die UFD-DE der Betriebsparameter (Ist) von der DE empfangen, wird der Wert aus dem
  Betriebsparamter (Ist) verwendet.

HINWEIS: Wird eine DE also in einer von 1-Minute abweichenden Intervalldauer betrieben und verhält
sich diese DE nicht TLS-konform (liefert also z. B. keine IST-Meldung der Betriebsparameter), kann
die korrekte Intervalldauer durch Senden der Betriebsparameter erzwungen werden.

## 06.08.2015 - V 5.4.0

Änderungen Umsetzungsklassen FG1 und FG3 gemäß AFo DUA KEx-15 und KEx-22

Die KExTlsOsi7 wurde dahin gehend geändert/erweitert, dass die überarbeiteten Anforderungen aus der
AFo-DUA (Anforderungen KEx-15 und KEx-22) vollständig umgesetzt werden. Die daraus resultierenden
wesentlichen Änderungen sind nachfolgend aufgeführt.

Änderung der Berechnungsvorschriften für qPkw und vKfz

Werden Verkehrsdaten der FG 1 über die Telegramme -FG 1 / Typ 49, 50, 51, 52, 53 (Version 0-4, 8
Bit)
-FG 1 / Typ 113, 114, 115, 116, 117 (Version 0-4, 16 Bit)
empfangen, so werden diese (wie bisher) neben den DE auch auf die

- atg.verkehrsDatenKurzZeitIntervall, asp.externeErfassung des zugeordneten Fahrstreifens (
  typ.fahrStreifen)
  abgebildet. Dabei werden auch die in den TLS-Telegrammen fehlenden Daten für qPkw und vKfz
  berechnet. Die Berechnung dieser Werte wurde einschließlich der Plausibilisierung der empfangenen
  Werte entsprechend der überarbeiteten Anforderungen aus der AFo-DUA
  (Anforderung KEx-15) implementiert. Treten bei der Berechnung und Prüfung Fehler/Probleme auf, so
  werden diese jetzt zusätzlich als Betriebsmeldung publiziert.

Versand von Betriebsmeldungen aus Umsetzungsmethoden

Es wurde die (ebenfalls in KEx-15) beschriebene Anforderung implementiert, innerhalb einer
Umsetzungsmethode eine Betriebsmeldung an die Betriebsmeldungsverwaltung zu senden.

Der Versand der Betriebsmeldung kann über einen neuen Paramter (atg.tlsBetriebsMeldungErzeugen)
am typ.de, der zur Laufzeit je DE ein- und ausgeschaltet werden (Standardeinstellung = Versand
eingeschaltet). Die entsprechende ATG ist enthalten im Datenmodell kv.inovat, kb.tmKExTlsGlobal ab
Version 21.

Zum Versand einer Betriebsmeldung steht die Methode

- public void sendMessage(String id, MessageType type, String messageTypeAddOn, MessageGrade grade,
  SystemObject referenceObject, MessageState state, String message)

zur Verfügung. Diese prüft selbständig den Zustand des Paramters
atg.tlsPassivierungÜbernahmeLogischesModell.

Zur Angabe der zu verwendenden Betriebsmeldungsverwaltung wurde ein neue Aufrufparamter

-pidBetriebsMeldungsVerwaltung=<Pid eines Objekts vom Typ typ.betriebsMeldungsVerwaltung>

hinzugefügt. Wird dieser nicht angegeben, so wird die AOE verwendet.

Passivierung von Umsetzungsmethoden in Richtung DaV

Entsprechend der Anforderung KEx-22 besteht nun die Möglichkeit, Umsetzungsmethoden zur Verarbeitung
von empfangen DE-Blöcken zur Laufzeit zu passivieren (d.h. die Methode liefert als
Ergebnissdatensatz null zurück, so dass kein Eintrag im DaV erfolgt). Dies dient insbesondere dazu,
dass die Daten der FG 1 bzw. FG 3 wahlweise zu Testzwecken nicht in das logische Modell übernommen
werden, um zuerst die TLS-Daten prüfen zu können. In der aktuellen Version wurde diese Funktion
implementiert für:
-Umsetzung aller FG 3 Umfelddaten in das logische Modell auf die Typen vom Basistyp typ.ufdsSensor
-Umsetzung der FG1 Verkehrsdaten der Typen -FG 1 / Typ 49, 50, 51, 52, 53 (Version 0-4, 8 Bit)
-FG 1 / Typ 113, 114, 115, 116, 117 (Version 0-4, 16 Bit)
auf die - atg.verkehrsDatenKurzZeitIntervall, asp.externeErfassung des zugeordneten Fahrstreifens (
typ.fahrStreifen)

Die Passivierung erfolgt dabei über einen neuen Paramter (
atg.tlsPassivierungÜbernahmeLogischesModell)
am typ.de, der zur Laufzeit je DE ein- und ausgeschaltet werden (Standardeinstellung = Passivierung
ausgeschaltet). Die entsprechende ATG ist enthalten im Datenmodell kv.inovat, kb.tmKExTlsGlobal ab
Version 21.

Um in einer Umsetzungsmethode von dieser Möglichkeit gebrauch zu machen, ist diese wie folgt zu
erweitern (Beispiel):

    ResultData FGxxxAtgYYYAspZZZ(DeBlock deBlock, Data data, DataDescription dataDescription) {
    
        // Die Ausführung von Umsetzungsmethoden kann zur Laufzeit über den
        // Parameter atg.tlsPassivierungÜbernahmeLogischesModell am typ.de
        // unterbunden werden, in dem der Zustand des Parameters ausgewertet
        // und bei Passivierung als return-Wert null zurückgegeben wird
    
        if (isPassivierungUmsetzungsMethoden()) {
            return null;
        }
    
        ...
        return resultData;
    }

## 04.05.2015 - V 5.3.3

Korrektur in Klasse DeConversionModul

Fehlerbehebung in der Methode

- private boolean isAllowedToSend(De de, DeBlock deBlock)
  In den switch/case Zweigen wurden fehlende break; ergänzt, da sonst im ungünstigsten Fall die
  Methode einen fehlerhaften Rückgabewert erzeugte (Meldung von Swarco/Hr. Drapp vom 30.04.2015)

## 21.08.2014 - V 5.3.2

Korrektur Umsetzungsscript für AXL, Typ 60 und Typ 61 sowie EakDefault für FG2

Korrektur Umsetzungsscript für AXL, Typ 60 und Typ 61, Initialisierungsfehler behoben

Neu seit TLS 2012: Wenn erster DE-Block FG2 und Typ31 erfolgt auch hier die Verarbeitung im
EakDefault!!
M. E. ein Fehler in der TLS, aber so wurde sie offiziell veröffentlicht!!!

Die zweite Prüfung wurde hinzugefügt:
if (((singleTelegram.getCountDeBlock() > 0) && (singleTelegram.getDeBlock()[0].getDeChannel() ==
255)) || // NEU wegen Fehler in TLS 2012
(singleTelegram.getCountDeBlock() > 0) && (singleTelegram.getDeBlock()[0].getFg() == 2) && (
singleTelegram.getDeBlock()[0].getTyp() == 31)) {

## 23.06.2014 - V 5.3.1

Korrektur Umsetzungsscript für defekte LED-Ketten FG 4 / Typ 5

Anpassung des Umsetzungsscripts von

ALT: int anzahlUebertrageneBytes = ((anzahlUebertrageneKetten-1)/8)+1;

nach

NEU: int anzahlUebertrageneBytes = (anzahlUebertrageneKetten+7)/8;

geaendert, da alte Implementierung bei fehlerfreien Ketten (anzahlUebertrageneKetten=0) zu einem
fehlerhaften Ergebnis der anzahlUebertrageneBytes=1 (statt 0) führte.

## 23.06.2014 - V 5.3.0

Unterdrückung des Versands von Kanalsteuerung an Clusterkanäle

Anpassung im DeConversionModul bie der Methode isAllowedToSend() bei der Prüfung, ob DeBlock
versendet werden darf. Hier wird jetzt zusätzlich geprüft, ob die De des zu versendenden ein
Clusterkanal ist. In diesem Fall wird der DeTyp 29 (Kanalsteuerung) nicht mehr versendet.

## 27.09.2013 - V 5.2.0

Anpassung FG3 an TLS 2012

!!!!! Benoetigt unbedingt kb.tmKExTlsGlobal ab Version 19 !!!!!

Siehe dazu auch Fehler-Nr. 84 im NERZ-Fehlermanagement (Meldung von Swarco im Zusammenhang mit
Problemen bei der SBA A8). In der TLS bis zur Version 2002 waren fuer eine Reihe von
Umfeldsensordaten (speziell die Daten mit negativen Werten)
keine Definitionen fuer den Wert "nicht ermittelbar" definiert. Bei der Anlage des Datenmodells (um
das Jahr 2001/2002)
wurden deshalb diese "nicht ermittelbar" Werte nicht definiert. In der TLS 2011/2012 sind diese
Werte jetzt definiert worden. Liefert nun ein neuer Sensor den entsprechenden Wert, fuehrte dies
bisher in der KExTlsOsi7 zu einer Exception mit der Folge, dass alle weiteren DE-Bloecke im
Telegramm nicht mehr verarbeitet wurden. Dieses Problem wurde mittlerweile dahingehend behoben, dass
seit der Version SWE_de.bsvrz.kex.tls.osi7_FREI_V5.1.3_D2013-01-19 die entsprechenden Werte
abgefangen werden und fuer diese DE "keine Daten" eingetragen werden.

Die korrekte Loesung ist die Anpassung des DatKat und der KExTlsOsi7 fuer diese Sensortypen. Im
Rahmen der Fachtelefonkonferenz der NERZ vom 19.02.2013, TOP 2, wurde festgestellt, dass dies
notwendigen aenderungen Anpassungen der KExTLS an die Weiterentwicklung der TLS sind und somit eine
aenderung gemaeß Festlegung des NERZ e.V. darstellen. Es wurde beschlossen, die Aenderung im Rahmen
des aenderungsmanagements durchzufuehren.

!!!!!
Hinweis:                                                                                                     !!!!!
!!!!! Durch die aenderungen gehen ggf. die bereits archivierten Sensorwerte der zu aendernden
Sen-sortypen verloren!!!!!
!!!!! (bzw. sind nur mit zusaetzlichem Aufwand reproduzierbar). Fuer Systeme, die von der aenderung
betroffen sind,!!!!!
!!!!! muss ein Migrationskonzept erstellt werden. Zustaendig sind die betroffenen
Laender.                         !!!!!
!!!!!                                                                                                              !!!!!
!!!!! Das neue Datenmodell setzt die Verwendung der KExTLSOsi7 ab Version 5.2.0 voraus, da hier
die                !!!!!
!!!!! Umsetzungsscripte auf das neue Datenmodell angepasst
wurden.                                                 !!!!!

Folgende Anpassungen wurden durchgefuehrt:

 Erweiterung des Wertebereichs von -32768  32767  Wert 32767 (7FFF) als <zustand name=nicht
ermittelbar wert=32767>

Folgene Typen wurden angepasst  FG 3, Typ 48: Lufttemperatur  FG 3, Typ 49:
Fahrbahnoberflaechentemperatur  FG 3, Typ 65: Gefriertemperatur  FG 3, Typ 66: Taupunkttemperatur
 FG 3, Typ 67: BodentemperaturInTiefe1  FG 3, Typ 68: BodentemperaturInTiefe2  FG 3, Typ 69:
BodentemperaturInTiefe3

## 26.09.2013 - V 5.1.7

Übernahme der Erweiterungen aus der SBA A8 BW

- FG 4 Typ 48: Workaround für Code 0 Funktion 1 als Dunkel übernehmen
- FG 1 Typ 28: Positive Quittung integriert
- FG 3 Typ 75: Schneefilmdicke integriert
- FG 3 Typ 77: Griffigkeit integriert
- FG 4 Typ 5: Defekte LED-Ketten integriert

## 15.04.2013 - V 5.1.6

Zugriffsmethode für DeAusfallUeberwachung ergaenzt

Damit ein Umsetzungsskript in einem anderen Paket unter Verwendung der DeAusfallUeberwachung
erstellt werden kann, wird das Datenmodell benötigt, das bisher nur über das DeConversionModul als
protected verfügbar war, und somit bei abgeleiteten Umsetzungsscripten nicht aufgerufen werden
konnte. Es wurde eine entsprechende Methode im DeConversionModul ergaenzt:

    /**
     * Liefert das aktuelle Datenmodell
     *
     * @return aktuelles Datenmodell
     */
    public DataModel getConfig() {
        return _config;
    }

## 22.02.2013 - V 5.1.5

Fehler Umsetzung für Fg004Default:Fg004Typ033Id003AtgTlsWzgGrundEinstellungAspParameterIst

in Fg004Default:Fg004Typ033Id003AtgTlsWzgGrundEinstellungAspParameterIst(DeBlock deBlock, Data data,
DataDescription dataDescription)
Zeilen 1521-1562 überall 'data.getArray("StellCode")' durch data.getArray("GruppenDefinition")
ersetzt.

19.02.2013 - V 5.1.4

Keine Parameter an DE == 0 senden, FG5-Typ 17 nicht bei DE255/0

Analog zu den DE255 werden auch an die DE0 keine Parameterdatensätze verschickt. Zusätzlich noch den
Typ 17 bei der FG 5 ergänzt (nicht schicken an DE255/DE0

## 19.01.2013 - V 5.1.3

Behebung Fehler #0000087:Fehlerhafte Zeitstempel bei der Umschaltung von Sommerzeit auf Winterzeit

Bei der Umschaltung von Sommer- auf Winterzeit ergaben sich Probleme mit den Zeitstempeln der
Verkehrsdaten (Problem besteht bei allen Zeitstempeln).

Die Analyse ergab, dass sobald ein Wert im GregorianCalendar gesetzt (set()) wird und vorher
Calendar.DST_OFFSET != 0 war, Calendar.DST_OFFSET wieder gesetzt werden muss, damit bei der
Neuberechnung der internen Werte das richtige Ergebnis bestimmt wird.

Im Programm muss nach der folgenden Zeile in der Methode setTimeStamp(7* int) in der Klasse
EakDefault

    int millisecond = gregorianCalendar.get(Calendar.MILLISECOND);

der folgende Abschnitt

    if (isTlsDST) // wenn ein Wert gesetzt wird, dann muss bei Sommerzeit DST_OFFSET nochmals gesetzt werden
    {
      gregorianCalendar.set(Calendar.DST_OFFSET, 3600000);
    }

eingefügt werden.

Bei den Test wurde dann immer der richtige Zeitstempel bestimmt.

inovat: Die entsprechende Ergänuzung wurde eingebaut.

Behebung Fehler #0000084:KExTls kann nicht mit 'Messwert kann nicht ermittelt werden' bei
Fahrbahnoberflächentemperatur umgehen

Enthält ein Einzeltelegramm der FG 3 den Typ 49 mit Wert 7FFF (32767) 'Messwert kann nicht ermittelt
werden', so führt dies zu einem Fehler. Der Typ 49 wird nicht publiziert und allen folgenden
DE-Blöcke werden verworfen. Das Verhalten führt zu großen Datenlücken im Bereich der FG 3, da von 15
Sensoren durch die Reihenfolge im Telegramm im Fehlerfall nur noch die Daten eines Sensors im DAV
ankommen.

inovat:
Dies ist leider kein richtiger Fehler sondern ein historisch bedingtes Feature. Als die KExTLS
erstellt wurde und insbesondere das zugehörige Datenmodell (2001/2002) gab es noch die TLS 93 / TLS
97 bzw. TLS 2002. Bei diesen TLS waren die Werte für 'Messwert kann nicht ermittelt werden' bei den
meisten UFD-Typen NICHT definiert. Aus diesem Grund sind die entsprechenden Werte NICHT im DatKat
definiert. Dies bedeutet, dass diese Messwerte (die jetzt in der aktuellen TLS 2012 definiert sind)
nicht im DatKat abgebildet werden können. Die korrekte Lösung wäre Anpassung des DatKat und
Anpassung der Umsetzungsscripte. Da die Anpassung des DatKat aber zu neuen ATG / neuen Objekt-IDs
führt, wurde dieser Schritt
(noch) nicht durchgeführt. Stattdessen wurden die Umsetzungsscripte für UFD-DE so angepasst, dass
diese (ungültigen) Werte abgefangen werden. Damit tritt dann zwar nicht mehr der Fehler auf, dass
folgende DE-Blöcke verworfen werden, der eigentliche Messwert wird aber nicht publiziert (d.h. dass
aktuell ein nicht ermittelbarer Messwert vorliegt, ist nicht erkennbar!!)

Behebung Fehler in writeNoDataToUnreachableDe()

Fehler beim Versenden von leeren Datensätzen, wnn eine DE mehreren Fahrstreifen zugeordnet war.
Fehlermeldung von Drapp/Swarco vom 18.01.2013

## 07.11.2012 - V 5.1.2

java.util.ConcurrentModificationException bei Zugriff auf das Feld '_davToTlsList'

Einbau von synchronized-Blöcken um gleichzeitigem Zugriff auf das Feld '_davToTlsList', einmal aus
der 'update'-Methode und aus der 'subscribeAllData'-Methode zu verhindern  (Meldung von BitCtrl, Hr.
Gieseler)

## 30.10.2012 - V 5.1.1

Fehlermeldungen bei FG wegen Doppelanmeldung für Cluster und Sammelkanäle abgefangen

Bei abgeleiteten DE-ConversionModulen der FG4 wurden die Cluster und Sammelkanäle ggf. mehrfach
angemeldet, was zu einer (nicht kritischen) Fehlermeldung führte (Meldung von BitCtrl, Hr. Gieseler)

## 25.10.2012 - V 5.1.0

WWW FG 5: typ.deWww aufgenommen

typ.deWww wird jetzt auch bei der Ermittlung der FG berücksichtigt (in den Konstruktoren der Klasse
De.java).

27.07.2012 - V 5.0.2

Zfr FG 9: BetriebsArt bei DE-Gutmeldung verschicken

Bei DE-Gutmeldung wird auch die BetriebsArt (9/17/2) verschickt.

## 04.04.2012 - V 5.0.1

Anpassung der Umsetzungscripte für die VRZ-Leverkusen

Lokale Aenderungen nur interessant fuer die VRZ Leverkusen in NRW:
Umsetzung der Typen TLS 71 (Niederschlagsart) und TLS 70 (Zustand Fahrbahnoberfläche) auf die
Boschung-Sensordaten auf Standard geändert, da die entsprechenden Typen bei Boschung 068 und 070 ab
2011/2012 nach TLS kodiert sind.

## 05.03.2012 - V 5.0.0

Ausfallueberwachung DE (Anforderung aus BW)

Zusaetzliche Aufrufparameter (angegeben ist jeweils die Standardeinstellung):

--------------------------------------------
-anzahlIntervalleFuerDatenAusfallErkennung=0
--------------------------------------------

Legt fest, wieviele Intervalllaengen keine Daten fuer ueberwachte DE emfangen werden duerfen, bevor
ein KEIN DATEN - Datensatz als Ausfallkennung geschrieben wird. In der FG 1 wird die Intervalllaenge
aus den Intervalldaten (Typ48, FG 1) ermittelt. In der FG 3 wird die Intervalllaenge aus den
BetriebsParametern (Typ 32, FG 3) oder behelfsweise aus dem Aufrufparameter
-standardPeriodenDauerUfdFuerDatenAusfallErkennungInSekunden ermittelt.

Die Wartezeit, bis ein Ausfall erkannt wird, betraegt

WarteZeit = IntervallDauer oder PeriodenDauer * Wert aus Parameter
-anzahlIntervalleFuerDatenAusfallErkennung). Die WarteZeit wird relativ zum Datenzeitstempel
ermittelt (also nicht unbedingt zum Empfangszeitpunkt).

---------------------------------------------------------------
-standardPeriodenDauerUfdFuerDatenAusfallErkennungInSekunden=60
---------------------------------------------------------------

Da bei der FG 3 die PeriodenDauer nur aus einem empfangenen Telegramm BetriebsParameter Typ 32
ermittelt werden kann, wird als Standard der angegebene Wert verwendet, solange fuer das ueberwachte
DE NOCH KEIN Telegramm vom Typ 32 empfangen wurde.

## 05.03.2012 - V 4.9.1

FG 9: Zuflussregelung gemaess TLS 2011 (Entwurf) vollstaendig integriert!

Ergänzung für unerlaubten Versand von Typen der FG9 bei DE255 (Parameter):

private boolean isAllowedToSend(DeBlock deBlock)
case 9:
switch (typ) { case 29:  // Kanalsteuerung case 32:  // Betriebsparameter case 33:  //
Betriebsparameter ALINEA1 case 34:  // Betriebsparameter Rotfahrerzähler case 35:  //
Betriebsparameter ALINEA2 case 36:  // Geografische Kenndaten case 48:  // Signalplan case 49:  //
Helligkeit return false; }

## 05.03.2012 - V 4.9.0

FG 9: Zuflussregelung gemaess TLS 2011 (Entwurf) vollstaendig integriert!

--> Benötigt kv.inovat mit - kb.tmKExTlsFG9 Version 1

Da die FG 9 analog zur FG 4 auch eine Folgenummerverwaltung enthält, gibt es hier ebenfalls anlog
den Aufrufparameter

-FolgenummernVerwaltungFg9=nein

mittels dessen die Folgenummernüberwachung ein (ja) bzw. ausgeschaltet (nein) werden kann. Standard
ist "nein".

## 15.12.2010

FG 4: Folgennummernfehler behoben!

Anmeldung als Sender für den DeBlockAbruf und den WzgPufferAbruf funktionieren jetzt. Ursache war,
dass die Sendesteurung trotz Anmeldung nicht erfolgt, wenn man die Sendesteuerung ausschaltet. Der
Grund für dieses (Fehl-)Verhalten des DaV ist noch nicht geklärt.

Erweiterungen der FG 1 und FG3 sowie Korrekturen

--> Benötigt kv.inovat mit - kb.tmKExTlsGlobal Version 15 - kb.tmUmfeldDatenGlobal Version 22 -
kb.tmVerkehrGlobal Version 46 --> Benötigt kv.logos mit - kb.tmLangZeitVerkehrsDaten Version 8

FG 1:
atg.kfzEinzelDatenFs wird jetzt auch für den Fahrstreifen unterstützt. Korrekturen bei der Umsetzung
von Langzeitdaten an MQ, FS und LZZS

FG 3:
Zusätzliche Umsetzungen für TLS und Logisches Umfelddatenmodell für folgende Sensoren:

FG	Typ	Bezeichnung
-------------------------------------------------
3 82 Stickoxide NOx 3 86 A-Bewerteter Schalldruckpegel 3 87 Energieäquivalenter Schalldruckpegel 3
88 Basispegel 3 89 Mittlerer Spitzenpegel

## 15.09.2010

FG 1

Umsetzungsscript für FG1 / Typ 79 (Langzeit Version 24) in Fahrstreifen,
verkehrsDatenLangZeitIntervallGeschwindigkeitVerteilungFs

09.09.2010

KRI2_B

- Unterstützung für die KRI2_B gemäß PLaNT der ASFINAG ergänzt.

## 07.09.2010

FG3

- Umsetzungsscripte für logisches Datenmodell "Teilmodell Umfelddaten Global" für folgende Typen
  ergänzt:

TYP TYP-TLS ATG UFDS 48 Lufttemperatur atg.ufdsLuftTemperatur 49 Fahrbahnoberflächentemperatur
atg.ufdsFahrBahnOberFlächenTemperatur 50 Fahrbahnfeuchte atg.ufdsFahrBahnFeuchte 51
Fahrbahnoberfläche atg.ufdsFahrBahnOberFlächenZustand 52 Restsalz atg.ufdsRestSalz 53
Niederschlagsintensitaet atg.ufdsNiederschlagsIntensität 54 Luftdruck atg.ufdsLuftDruck 55 Relative
Luftfeuchte atg.ufdsRelativeLuftFeuchte 56 Windrichtung atg.ufdsWindRichtung 57
Windgeschwindigkeit (Mittel)                    atg.ufdsWindGeschwindigkeitMittelWert 58 Schneehöhe
atg.ufdsSchneeHöhe 59 Fahrbahnglätte (nicht definiert in TLS)         --> Keine Abbildung möglich 60
Sichtweite atg.ufdsSichtWeite 61 Helligkeit atg.ufdsHelligkeit 62 Niederschlagsmenge (nicht
definiert in TLS)     --> Keine Abbildung möglich 63 Niederschlagsart atg.ufdsNiederschlagsArt 64
Windgeschwindigkeit (Spitze)                    atg.ufdsWindGeschwindigkeitSpitzenWert 65
Gefrierpunkttemperatur atg.ufdsGefrierTemperatur 66 Taupunktemperatur atg.ufdsTaupunktTemperatur 67
Temperatur Tiefe 1 (6 cm Tiefe)                 atg.ufdsTemperaturInTiefe1 68 Temperatur Tiefe 2
atg.ufdsTemperaturInTiefe2 69 Temperatur Tiefe 3 (Tiefe 3 = 30 cm)
atg.ufdsTemperaturInTiefe3 70 Zustand der Fahrbahnoberflaeche atg.ufdsFahrBahnOberFlächenZustand 71
Niederschlagsart atg.ufdsNiederschlagsArt 72 Wasserfilmdicke FR Nord atg.ufdsWasserFilmDicke

## 13.07.2010

FG1

- Umsetzungsscripte FG001HeuschBoesefeldt public ResultData
  Fg001Typ160Id004AtgVerkehrsDatenKurzZeitIntervallAspMessWertErsetzung angepasst gemäß Vorschlag
  Hr. Drapp / Dambach

## 25.03.2010

FG3

- Umsetzungsscripte für Typ Typ 54: "atg.tlsUfdErgebnisMeldungLuftDruckLD"
  Fg003Typ054Id004AtgTlsUfdErgebnisMeldungLuftDruckLDAspTlsAntwort() korrigiert:
  -von 8-Bit auf 16-Bit, siehe EMail LOGOS vom 25.03.2010

## 04.11.2009

Erweiterung der KExTLSOSI7 auf Basis der Unterlagen von Herrn Strey/LOGOS:

====================================================== ACHTUNG: Benötigt den kb.tmKExTlsGlobal ab
Version 8 ======================================================

FG1

- Erweiterung um den Langzeitdatentyp Typ 79

28.10.2009 Erweiterung der KExTLSOSI7 auf Basis der Unterlagen von Herrn Gieseler/BitCtrl:

====================================================== ACHTUNG: Benötigt den kb.tmKExTlsGlobal ab
Version 7 ======================================================

FG254

- Dateitransver implementiert

FG4

- Umsetzungsscripte für Typ 22 "Abruf Bilddefinition/Grafiktextkonserve":
  atg.tlsWzgAbrufBildDefinition
- Umsetzungsscripte für Typ 45 "Bilddefinition/Grafiktextkonserve": atg.tlsWzgBildDefinition

FG2

- Umsetzungsscripte für Typ Typ 62: "
  atg.tlsAxlEinzelErgebnisMeldungAchsLastenUndKfzGesamtGewichteVersion3"
- !!!FEHLT NOCH!!!: Umsetzungsscripte Typ 66: "atg.tlsAxlErgebnisMeldungAchsLastDatenVersion11",
  ================ im aktuellen DatKat bereits vorhanden

--------------------------------------------

## 18.05.2009

--------------------------------------------
Mögliches Syncronisationsproblem beim Zugriff auf die Sendequeue behoben (Hinweis von Roland
Schmitz):

While-Schleife war bisher nicht syncronisiert:

		synchronized (_queue) {
			while (!_queue.isEmpty()) {
				list.add(_queue.removeLast());
			}
		}

## 06.04.2009

--------------------------------------------
Umsetzungsscrpte für FG2 de.bsvrz.kex.tls.osi7.conversion.Fg002Default geändert:

In der Definition des DE-Typ 21 "Abruf Pufferinhalt Einzelergebnismeldungen"
ist die Angabe des Jahres als 2 Byte (0-9999) definiert. In '
Fg002Typ021Id002AtgTlsAxlAbrufPufferInhaltEinzelErgebnisMeldungenAspTlsAbruf' wurde die Zeile

_Jahr_ = (gregorianCalendar.get(Calendar.YEAR) - 2000);

durch

_Jahr_ = gregorianCalendar.get(Calendar.YEAR);

Der Abruf wurde damit durch die Streckenstation (Hersteller ursprünglich Weiss-Electronic)
akzeptiert (BitCtrl, Gieseler).

## 23.03.2009

--------------------------------------------
Umsetzungsscrpte für FG1 VRZ-Leverkusen: Fehler in Script behoben (gemäß Fehlerbeschreibung Christop
Westermann (KS).

Im Umsetzungsmodul Fg001HeuschBoesefeldt sind u.a. folgende Umsetzungen definiert:

{"atg.verkehrsDatenKurzZeitIntervall", "asp.messWertErsetzung", "1", "160", "4", "typ.fahrStreifen"
}, {"atg.tlsLveErgebnisMeldungVersion0Bis4", "asp.tlsAntwort", "1", "160", "4", "typ.deLve"},

Also, wenn ein Telegramm von Heusch/Boesefeldt der Fg 1 mit dem Typ 160 empfangen wird, sendet KEx
zu den beiden Attributgruppen unter den angegebenen Aspekten für die entsprechenden
Konfigurationsobjekte Datensätze. Bei der Umsetzung werden in den Umsetzungsmethoden aber
unterschiedliche Methoden zum Lesen der Mengenwerte benutzt.

Fg001Typ160Id004AtgVerkehrsDatenKurzZeitIntervallAspMessWertErsetzung:
_qKFZ_ = deBlock.getDeData().readUnsignedHighLowByteAsInt();

Fg001Typ160Id004AtgTlsLveErgebnisMeldungVersion0Bis4AspTlsAntwort:
_qKfz_ = deBlock.getDeData().readUnsignedLowHighByteAsInt();

Im Sendeskript von Heusch/Boesefeldt ist für Telegramme der Fg 1 mit dem Typ 160 definiert:

/* Fg 1 Id 132 Typ 160 --------------- Intervalldaten Kurzzeit Interpoliert */ Datatype
DaLVEKurzInterpolOpt0 mit Zeit (UnixZeit, UnixArchivZeit)
Reaktion Write Area NUR_AKTUELL_SENDEN Fill High     (qKFZ)          /*
KFZ-Menge                                  */ Fill Low      (qKFZ)

Demnach muss bei der Umsetzung für die Attributgruppe "atg.tlsLveErgebnisMeldungVersion0Bis4"
für die Behandlung der Mengenwerte auch die Methode readUnsignedHighLowByteAsInt() benutzt werden.

## 17.11.2008

--------------------------------------------
Neuer Aufrufparamter: -ZeitsyncronisationVerschicken=ja

Erläuterung:
"-ZeitsyncronisationVerschicken" gibt an, ob die OSI7 bei einem TOT-->LEBT Übergang eine Zeitsync
verschickt. Der Defaultwert ist "ja" (es wird also eine Zeitsync verschickt). Bei
-ZeitsyncronisationVerschicken=nein verschickt die OSI7 keine Zeitsyncronisationstelegramme mehr.

## 16.11.2008

--------------------------------------------
Umsetzungsscrpte für FG4 VRZ-Leverkusen zum Nachfordern für Schaltinformationen der dWiSt-Tafeln.

Fehlenden Eintrag für das Versenden der atg.tlsGloDeBlockAbruf für die FG004HeuschBoesefeld ergänzt.
private final Object[][] davToTls = new Object[][]{ // Attributgruppe, Aspekt, Fg, Typ, Id,
ObjektTyp neu --->    {"atg.tlsGloDeBlockAbruf", "asp.tlsAbruf", "255", "255", "255", "typ.deWzg"},
{"atg.tlsWzgWvzStellZustand", "asp.tlsVorgabe", "4", "48", "81", "typ.deWzg"}, {"
atg.tlsWzgWechselText", "asp.tlsVorgabe", "4", "50", "81", "typ.deWzg"}, };

## 07.11.2008

--------------------------------------------
Umsetzungsscrpte für FG4 VRZ-Leverkusen zum Nachfordern für Schaltinformationen der dWiSt-Tafeln.

Fehler beim Versand des Abfragetelgramms behoben (falsche ATG verwendet).

## 29.10.2008

--------------------------------------------
Umsetzungsscrpte für FG4 VRZ-Leverkusen zum Nachfordern für Schaltinformationen der dWiSt-Tafeln
ergänzt.

Bei der Kommunikation mit der VRZ werden die Daten zu folgenden ATG/ASP-Kombinationen abgefragt,
damit insbesondere die dWiSta-Tafeln in dMotion korrekte Inhalte anzeigen:
Problem: Bei der Kommnikation über WAN-COM mit der HB-VRZ werden nach einer DE-Gutmeldung keine
Stellzustandsdaten etc. von der HB-VRZ an die neue VRZ gesendet.

ATG ASP TYP ID Kommentar für Symbole:

atg.tlsGloDeFehler asp.tlsAntwort 1 1 ist vorhanden (keine Abfrage)
atg.tlsWzgNichtDarstellbareWVZ asp.tlsAntwort 2 1 Nicht darstellbare WVZ atg.tlsWzgWvzStellZustand
asp.tlsZustand 48 5 WVZ Stellzustand atg.tlsGloKanalSteuerung asp.parameterIst 29 2 Kanal-Steuerung

für Wechseltexte:

atg.tlsGloDeFehler asp.tlsAntwort 1 1 ist vorhanden (keine Abfrage)
atg.tlsWzgGestörteTextPositionen asp.tlsAntwort 4 1 Gestörte Textpositionen atg.tlsWzgWechselText
asp.tlsZustand 50 5 Wechseltext atg.tlsGloKanalSteuerung asp.parameterIst 29 2 Kanal-Steuerung

## 17.06.2008

--------------------------------------------
Fehler in Umsetzungsscripten der FG3 und FG6 bei Attributgruppe Tls???BetriebsParameter behoben.

Erläuterung:
In den folgenden Dateien wird in der Attributgruppe Tls???BetriebsParameter auf das Attribut "_
Erfassungsperiodendauer_" zugeriffen, das Attribut heißt im aktuellen DaK aber "
Erfassungsperiodendauer", ohne die Unterstriche:

Geänderte Klassen:

de\bsvrz\kex\tls\osi7\conversion\nw\vrz\Fg003HeuschBoesefeldt.java
de\bsvrz\kex\tls\osi7\conversion\nw\vrz\Fg006HeuschBoesefeldt.java
de\bsvrz\kex\tls\osi7\conversion\Fg003Default.java
de\bsvrz\kex\tls\osi7\conversion\Fg006Default.java

## 18.06.2008

--------------------------------------------
Fehler beim Ermitteln von referzierten DE (z.B. Fahrstreifen --> DE) behoben.

Erläuterung:
Waren in der Konfiguration fehlerhafte Einträge (z. B. null), so wurde beim Zugriff auf diese
Referenz eine NULL-Pointer Exception geworfen. In der geänderten Version wird jetzt unter
debug.config eine Warnung ausgegeben.

## 14.05.2008

--------------------------------------------
Fehler in TlsApplicationLayer.java behoben.

Erläuterung:
In der Version vom 06.05.2008 war für den Zugriff auf die Klasse Sm per Reflection-Interface noch
der alte Packagename eingetragen (kex.tls.osi7.Sm statt de.bsvrz.kex.tls.osi7.Sm).

## 06.05.2008

--------------------------------------------
Fehler in De.java behoben.

Erläuterung:
In der Version vom 01.05.2008 war für die Defaultklasse der FG004 ein falscher Klassenname
eingetragen
(Leerzeichen im Namen).

## 01.05.2008

--------------------------------------------
Umstellung der KEx-TLS-OSI7 auf die neue Packagestruktur de.bsvrz.*

Erläuterung:
Mit der Version 3.x wurde das Kernsystem und auch alle anderen SWE auf eine einheitliche
Packagestruktur umgestellt. Danach beginnen alle Packages des BSVRZ mit de.bsvrz.*.

Für die KEx-TLS-OSI7 bedeutet dies, das neben der Anpassung der verwendeten Packages auf die neue
Kernsoftwarestruktur das Package kex.tls.osi7.* auf das neue Package de.bsvrz.kex.tls.osi7.*
angepasst wurde.

--------------------------------------------
Kompatibilitätsmodus für Umsetzungsmodule der KEx-TLS-OSI7 nach Anpassung auf die neue
Packagestruktur de.bsvrz.*

Erläuterung:
In der KEx-TLS-OSI7 können die Umsetzungsmodule je DE in der Konfigurations angeben werden. Dazu
wird in der Konfiguration der voll qualifizierte Klassenname eingetragen, also z. B. in der alten
Packagestruktur
"kex.tls.osi7.conversion.Fg003Typ065". Die entsprechende Umsetzungsklasse wird dann per Reflection
geladen und instanziert. Mit der Umstellung auf die neue Packagestruktur würde dies bei den
aktuellen Konfigurationen mit der Verwendung der aktuellen KEx-TLS-OSI7 zu einem Fehler führen, da
die Klasse jetzt unter
"de.bsvrz.kex.tls.osi7.conversion.Fg003Typ065" zu finden ist. Damit die bestehenden Konfigurationen
weiterverwendet werden können, wird von der aktuellen KEx-TLS-OSI7 automatisch folgende
Konvertierung des in der Konfiguration eingetragenen Umsetzungsklassennamens durchgeführt:

Beginnt der Klassenname des Umsetzungsmoduls mit "kex.tls.osi7.conversion." (und nur dann !, also
z.B.
"kex.tls.osi7.conversion.WEITER_ANGABE") ), dann wird die Umsetzungsklasse nicht im angegebenen
Package sondern unter "de.bsvrz.kex.tls.osi7.conversion.WEITER_ANGABE"
gesucht und von dort geladen.

Softwaretechnisch ist dies wie folgt gelöst:

			if (Pattern.matches("^kex\\.tls\\.osi7\\.conversion\\..*", _conversionModulName)) {
				_conversionModulName = ("de.bsvrz." + _conversionModulName).trim();
			}

--------------------------------------------
Fehler in Umsetzungsmodule Fg001HeuschBoesefeldt bei der Methode public ResultData
Fg001Typ160Id004AtgVerkehrsDatenKurzZeitIntervallAspMessWertErsetzung(...) bei der Berechnung der
Werte qPKW und vKFZ behoben (zusätzlicher Test, ob einer der zur Berechnung benötigten Werte
TLS-seitig auf nicht ermittelbar gesetzt war.

Erläuterung:
Zusätzlich die if(...) Prüfungen eingebaut.

		int _qPKW_ = -1;
		if ((_qKFZ_ != 0xffff) && (_qLKW_ != 0xffff)) {
			_qPKW_ = (_qKFZ_ - _qLKW_) > 0 ? (_qKFZ_ - _qLKW_) : 0;
		}
	
		int _vKFZ_ = -1;
		if ((_qLKW_ != 0xffff) && (_qPKW_ != 0xffff) && (_vLKW_ != 0xff) && (_qPKW_ != 0xff)) {
			_vKFZ_ = (_qLKW_ + _qPKW_) > 0 ? ((_qLKW_ * _vLKW_) + (_qPKW_ * _vPKW_)) / (_qLKW_ + _qPKW_) : -1;
		}

## 25.06.2007

--------------------------------------------
Änderung der Umsetzungsscipte zum Störfallindikator

Erläuterung:
Mit der neuen Kernsoftware Release 3.0 wurde auch das Datenmodell u. a. für die Attributgruppe "
atg.störfallZustand"
geändert (Keine Referenz mehr auf Infrastrukturobjekt, dafür Zeitdauer "T" = Intervalldauer, mit dem
die Werte erfasst wurden).

In den Umsetzungsscripten für VRZ-Leverkusen/HB (FG001HeuschBoesefeldt) wurden folgende Änderungen
durchgeführt:
Methoden:
public ResultData Fg001Typ144Id004AtgStörfallZustandAspStörfallVerfahrenNRW(...)
public ResultData Fg001Typ152Id004AtgStörfallZustandAspStörfallVerfahrenNRW(...)
public ResultData Fg001Typ182Id004AtgStörfallZustandAspStörfallVerfahrenRDS(...)
public ResultData Fg001Typ250Id004AtgStörfallZustandAspStörfallVerfahrenRDS(...)

Zeile gelöscht:
data.getReferenceValue("InfrastrukturObjekt").setSystemObject(null);

Zeile eingefügt:
data.getTimeValue("T").setSeconds(60);

--------------------------------------------
Änderung Umsetzungsscript FG4-Default, Fg004Typ050Id005AtgTlsWzgWechselTextAspTlsVorgabe, Absturz
beim Versenden

Erläuterung: Absturz der KEx-TLS beim Versenden der ATG TlsWzgWechselText, Aspekt TlsVorgabe (die
nachfolgende Änderung behebt den Fehler gemäß "Prüfbericht V 0.02 von Dambach, Stand 06.02.07,
Kapitel 4.21 Prüffalle
"FG4 Typ 50 Wechseltext", Prüffall 1, Seite 87"):

public DeBlock Fg004Typ050Id005AtgTlsWzgWechselTextAspTlsVorgabe(ResultData result) { DeBlock
deBlock = null;

		// Datenblock beseht aus folgenden Inhalten:
		int _Funktion_ = 0;
		int _Textzeichen_;
	
		// Umsetzung
		Data data = result.getData();// Datensatz holen
		int count = data.getArray("WVZTextZeichen").getLength();
		                                         ^
	                                             |
	                                     !!Hier war ein Leerzeichen!!

Änderungen in FG004Default und FG004Duerr durchgeführt.

--------------------------------------------
Änderung der Umsetzungsscripte OSI 7 bzgl. der Güte-Attribute

Erläuterung:
Mit der neuen Kernsoftware Release 3.0 wurde auch das Datenmodell u. a. für den Attributtyp "
att.güteIndex" geändert
(Nachkommastellen von 0,1 auf 0,0001). In den Umsetzungsscripten wurde bisher der Zugriff wie folgt
realisiert:

...getItem("Güte").getUnscaledValue("Index").set(10);

d. h. also mit Unscaled-Zugriff und setzen als 10 --> 1.0.

Alle Stellen wurden jetzt geändert auf Scaled-Zugriff:

...getItem("Güte").getScaledValue("Index").set(1.0);

## 08.10.2005

--------------------------------------------
Änderung des Datenmodells TLS

Erläuterung:
Für das syncrone Versenden von mehreren DE-Blöcken in einem Einzeltelegramm (z. B. in der FG 4,
Schalten kompletter AQ)
wurde am EAK (typ.eak) und SM (typ.steuerModul) eine zusätzliche Attributgruppe "
TlsSendenEinzelTelegramm" angelegt. Über das Attribut "Senden" (mögliche Zustände "senden" und "
verwerfen", kann jetzt gesteuert werden, dass alle an diesem EAK zwischengespeicherten DE-Blöcke am
Stück zu einem (oder mehreren) Einzeltelegrammen zusammengestellt werden und versandt werden (bzw.
aus dem Puffer gelöscht werden). Eine Triggerung am SM bewirkt eine Triggerung an allen EAK des SM.
Welche DE-Blöcke für diesen Mechanismus zwischengespeichert werden, wird über eine entsprechende
Klasse über Aufrufparameter festgelegt --> siehe "Neuer Aufrufrufparamter:
-DeBloeckeFuerEinzelTelegramme"

--------------------------------------------
Neuer Aufrufparamter: -DeBloeckeFuerEinzelTelegramme=kex.tls.osi7.conversion.CollectDeBlocksDefault

Erläuterung:
"-DeBloeckeFuerEinzelTelegramme" gibt die Klasse an, in der die FG/Typ/ID Kombinationen angegeben
werden, bei denen der DE-Block nicht direkt versendet sondern je EAK zwischengespeichert wird. Die
zwischengespeicherten DE-Blöcke werden erst nach Triggerung am EAK oder übergeordneten SM gemäß TLS
in ein oder mehrere TLS-Einzeltelegramme zusammengepackt und versandt (notwendig z. B. in der FG 4,
um komplette Anzeigequerschnitte mit einem Telegramm zu schalten). Standardmäßig (ohne
Aufrufparameter) wird die Klasse "kex.tls.osi7.conversion.SendingOsi7AdressNullDefault" verwendet,
die zum Standardlieferumfang der KExTLS gehört. Werden in spezifischen Projekten andere Festlegungen
benötigt, so ist die Klasse kex.tls.osi7.conversion.SendingOsi7AdressNullDefault unter einem
anderen (projektspezifischen) Namen zu kopieren und die notwendigen Eintrage im Feld "private static
final int[][] _sendingOsi7AdressNull" einzutragen und die kopierte Klasse beim Start über den oben
beschriebenen Aufrufparameter anzugeben.

--------------------------------------------
Neuer Aufrufparamter:
-DeBloeckeMitOsi7AdresseNull=kex.tls.osi7.conversion.SendingOsi7AdressNullDefault

Erläuterung:
"-DeBloeckeMitOsi7AdresseNull" gibt die Klasse an, in der die FG/Typ/ID Kombinationen angegeben
werden, bei denen das Telegramm mit Knotennummer (00 00 00) gesendet werden muss (z. B. FG 254,
Knotennummer senden). Standardmäßig (ohne Aufrufparameter) wird die Klasse "
kex.tls.osi7.conversion.SendingOsi7AdressNullDefault" verwendet, die zum Standardlieferumfang der
KExTLS gehört. Werden in spezifischen Projekten andere Festlegungen benötigt, so ist die Klasse
kex.tls.osi7.conversion.SendingOsi7AdressNullDefault unter einem anderen (projektspezifischen) Namen
zu kopieren und die notwendigen Eintrage im Feld "private static final int[][] _
sendingOsi7AdressNull" einzutragen und die kopierte Klasse beim Start über den oben beschriebenen
Aufrufparameter anzugeben.
(Bisher waren diese Einstellung unveränderbar im Source festgelegt, mit dieser Änderung können die
Einstellungen jetzt projektspezifisch angepasst werden).

--------------------------------------------
Neuer Aufrufparamter: -nurSendenAnDeOk=nein

Erläuterung:
"-nurSendenAnDeOk" legt fest, ob zu versendende De-Blöcke nur dann verschickt werden, wenn zum
Zeitpunkt der Telegramm- erzeugung für das betreffende DE eine DE-Gutmeldung anliegt (Aufruf mit "
ja"). Ohne Angabe dieses Aufrufparameters bzw. bei Aufruf mit "nein" (Standardeinstellung), werden
die DE-Blöcke unabhängig vom Status des DE verschickt.

--------------------------------------------
Neuer Aufrufparamter: -nurSendenAnVerbundeneSM=nein

Erläuterung:
"-nurSendenAnVerbundeneSM" legt fest, ob ein zu versendendes Telegramm nur dann verschickt wird,
wenn zum Zeitpunkt der Versendung des Telegramms zu dem betroffenen Zielknoten (SM) eine Verbindung
besteht (Aufruf mit "ja"). Ohne Angabe dieses Aufrufparameters bzw. bei Aufruf mit "nein" (
Standardeinstellung), wird das Telegramm von der OSI-7 an die OSI-3 zum Versand weitergereicht (kann
dort aber je nach OSI-2/OSI-3 Modul trotzdem wegen fehlender Verbindung verworfen werden).
 --------------------------------------------
Neue Funktionalität/Verhalten beim Zusammenstellen der Einzeltelegramme aus De-Blöcken

(siehe auch neuer Aufrufparameter -DeBloeckeFuerEinzelTelegramme)

Es wird nicht mehr wie bisher jeder DE-Block alleine in ein Einzeltelegramm verpackt und verschickt,
sondern es werden aktuell zum Verand bereitstehenden DE-Blöcke (genau: alle DE-Blöcke, die innerhalb
von 1000ms nach dem ersten DE-Block in der Sendequeue stehen) optimal in ein oder mehrere
Einzeltelegramme verpackt und versendet.

--------------------------------------------
Anpassung Umsetzungsklassen FG004Default

Fehler in der Umsetzung bei der Bildung des DE-Blocks behoben (Attributname hatte Tipfehler):

Fg004Typ048Id005AtgTlsWzgWvzStellZustandAspTlsZustand

## 14.05.2005

--------------------------------------------
Neuer Aufrufparamter: -QuellDatenReferenzen=kex.tls.osi7.conversion.SourceDataReferencesDefault

Erläuterung:
"-QuellDatenReferenzen" gibt die Klasse an, die zur Ermittlung von Objektreferenzen aus den
Fachmodellen auf die zugehörigen DE-Objekte verwendet werden soll (z. B. ist hier eingetragen, wie
Referenzen von Objekten des Typs typ.fahrStreifen auf Objekte vom Typ typ.de ermittelt werden
können. Standardmäßig (ohne Aufrufparameter) wird die Klasse
"kex.tls.osi7.conversion.SourceDataReferencesDefault" verwendet, die zum Standardlieferumfang der
KExTLS gehört. Hier sind alle Referenzschemata eingetragen, für die die entsprechenden logischen
Datenmodelle im Datenkatalog aktuell definiert sind. Werden in spezifischen Projekten eigene
Attributgruppen mit Referenzen auf DE angelegt, für die die entsprechenden Mechanismen der KExTLS
verwendet werden sollen, so ist die Klasse
de.bsvrz.kex.tls.osi7.conversion.SourceDataReferencesDefault abzuleiten, die notwendigen Einträge
sind im Feld "private static final Object[][] sourceDataReferences" hinzuzufügen und die abgeleitete
Klasse beim Start über den oben beschriebenen Aufrufparameter anzugeben.

--------------------------------------------
Neue Methode "public ClientDavInterface getClientDavInterface()"
in den Interfaces DeConversionInterface, EakConversionInterface, DeviceConversionInterface

	/**
	 * Ermöglicht den Zugriff auf die aktuelle Datenverteilerverbindung.
	 *
	 * @return Gibt die aktuelle aktuelle Datenverteilerverbindung zurück.
	 */
	public ClientDavInterface getClientDavInterface();

Erlaubt in speziellen Fällen den Zugriff auf die aktuelle Datenverteilerverbindung und damit auch
auf die Konfiguration in den Umsetzungsklassen.

--------------------------------------------
Anpassung Umsetzungsklassen FG004Default

Bei den Rückmeldungen für die Blinkdauer wird in den folgenden Umsetzungsmethoden im Falle einer
eigentlich fehlerhaften Blinkdauerrückmeldung nur eine Warnung ausgegeben und die Blinkdauer auf
einen gültigen Wert (200ms)
gesetzt (die meisten Hersteller von TLS Geräten liefern den entsprechenden Eintrag i.d.R. falsch
zurück !!!!).

Fg004Typ032Id003AtgTlsWzgWvzGrundEinstellungAspParameterIst
Fg004Typ033Id003AtgTlsWzgGrundEinstellungAspParameterIst
Fg004Typ044Id003AtgTlsWzgCodeDefinitionAspParameterIst
Fg004Typ048Id005AtgTlsWzgWvzStellZustandAspTlsZustand
Fg004Typ050Id005AtgTlsWzgWechselTextAspTlsZustand

--------------------------------------------
Ausschalten von WVZ-Anzeigen

Da sich eine Reihe von Softwareentwicklern für die SM/EAK-Software bei den Firmen auf eine etwas
seltsame Interpretation der TLS im Falle des Ausschaltens von WVZ-Anzeigen versteift (1), wird bis
zur verbindlichen Festlegung einer vernünftigen Interpretation ein WVZ beim Ausschalten jeweils mit
dem letzten empfangenen WVZ-Code einer Einschaltsequenz ausgeschaltet.

(1) Das Schalten einer WVZ-Anzeige erfolgt über zwei Steuerbyte: dem eigentlichen Befehl ob ein-
oder auszuschalten ist und dem darzustellenden WVZ-Code. Letzterer macht logischerweise nur Sinn
beim Einschalten. Einige Entwickler versteifen sich aber darauf, dass auch beim Ausschalten ein
gültiger Code verwendet werden muss und schalten das WZG ansonsten nicht aus (obwohl kein Mensch
erklären kann, warum hier so ein unnötiger Programmieraufwand getrieben wird, der zudem einen
sicheren Betrieb erheblich erschwert...Im Zweifelsfall kann nämlich eine Fehlanzeige nicht ohne
weiteres über eine Mánuelle Schaltung ausgeschaltet werden, weil die Liste der gültigen Anzeigecode
nicht bekannt ist!!).

Telegramme, bei den aus der Rückmeldung gültige Codes gemerkt werden:

Fg004Typ032Id003AtgTlsWzgWvzGrundEinstellungAspParameterIst
Fg004Typ033Id003AtgTlsWzgGrundEinstellungAspParameterIst
Fg004Typ043Id003AtgTlsWzgCodeListeAspTlsAntwort
Fg004Typ044Id003AtgTlsWzgCodeDefinitionAspParameterIst
Fg004Typ048Id005AtgTlsWzgWvzStellZustandAspTlsZustand

Telegramme, bei denen der letzte gemerkte gültige Code beim AUSSCHALTEN ins Telegramm eingetragen
wird:
Fg004Typ032Id003AtgTlsWzgWvzGrundEinstellungAspParameterSoll
Fg004Typ033Id003AtgTlsWzgGrundEinstellungAspParameterSoll
Fg004Typ044Id003AtgTlsWzgCodeDefinitionAspParameterSoll
Fg004Typ048Id005AtgTlsWzgWvzStellZustandAspTlsVorgabe
Fg004Typ055Id005AtgTlsWzgStellZustandAspTlsVorgabe
 --------------------------------------------


[Noch nicht veröffentlicht]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/compare/v5.
13.0...HEAD

[Version 5.13.0]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/compare/v5.12.0...v5.13.0
[Version 5.12.0]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/compare/v5.11.0...v5.12.0
[Version 5.11.0]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/compare/v5.11.0...v5.12.0
[Version 5.11.0]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/compare/v5.10.0-BETA...v5.11.0
[Version 5.10.0-BETA]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/compare/v5.9.1...v5.10.0-BETA

[Version 5.9.1]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/compare/v5.9.0...v5.9.1

[Version 5.9.0]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/compare/v5.8.0...v5.9.0

[Version 5.8.0]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/compare/v5.7.0...v5.8.0

[Version 5.7.0]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/compare/v5.6.0...v5.7.0

[Version 5.6.0]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/compare/v5.5.2...v5.6.0

[Version 5.5.2]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/compare/v5.5.1...v5.5.2

[Version 5.5.1]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/compare/v5.5.0...v5.5.1

[Version 5.5.0]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/compare/v5.4.11...v5.5.0

[Version 5.4.11]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/compare/v5.4.10...v5.4.11


